# IRdProceduralSkinNormalsStream Interface Reference

Inherits IUnknown.

List of all members.

## Public Member Functions
HRESULT | SetProperties (IRdTriangleStream *pTriangles, IRdVertexStream *pVertices, IRdTriangleNormalsStream *pNormalsIndices, IRdNormalsSkinStream *pNormalsData)
HRESULT | GetVertexStream (IRdVertexStream **ppVertices)
HRESULT | GetTrianglesStream (IRdTriangleStream **ppTriangles)
HRESULT | GetNormalsIndices (IRdTriangleNormalsStream **ppIndices)
HRESULT | GetNormalsData (IRdNormalsSkinStream **ppData)

## Detailed Description

IRdProceduralSkinNormalsStream:

- Specifies vertex skinning normals for normal indices (IRdTriangleNormalsStream) that are calculated in a lazy way - when stream is locked.
- The stream is part of IRdMesh and is stored in custom stream group.
- Stream is identified by STREAMID_NORMALS id.

## Member Function Documentation

HRESULT IRdProceduralSkinNormalsStream::SetProperties | ( | IRdTriangleStream * | pTriangles,
|  | IRdVertexStream * | pVertices,
|  | IRdTriangleNormalsStream * | pNormalsIndices,
|  | IRdNormalsSkinStream * | pNormalsData |
| ) |  |  |

Set properties for procedural normal stream that are used to calculate real stream.

Parameters:

  | pTriangles | is mesh triangle stream used to calculate triangle normals.
  | pVertices | is vertex stream (skinned) used to calculate triangle normals.
  | pNormalsIndices | is normals index stream used for smoothing.
  | pNormalsData | is normals data stream of base pose.

HRESULT IRdProceduralSkinNormalsStream::GetVertexStream | ( | IRdVertexStream ** | ppVertices | ) |

Return stored vertex stream. Method is used by RdVertexSkinNormalsCache to calculate real normals.

Parameters:

  | ppVertices | is filled with stored vertices used for calculation of normals.

HRESULT IRdProceduralSkinNormalsStream::GetTrianglesStream | ( | IRdTriangleStream ** | ppTriangles | ) |

Return stored triangle indices stream. Method is used by RdVertexSkinNormalsCache to calculate real normals.

Parameters:

  | ppTriangles | is filled with stored triangles used for calculation of normals.

HRESULT IRdProceduralSkinNormalsStream::GetNormalsIndices | ( | IRdTriangleNormalsStream ** | ppIndices | ) |

Return stored normals indices stream. Method is used by RdVertexSkinNormalsCache to calculate real normals.

Parameters:

  | ppIndices | is filled with stored normals used for calculation of normals.

HRESULT IRdProceduralSkinNormalsStream::GetNormalsData | ( | IRdNormalsSkinStream ** | ppData | ) |

Return stored base-pose normals data stream. Method is used by RdVertexSkinNormalsCache to calculate real normals.

Parameters:

  | ppData | is filled with stored normals used for normals calculations.